/***************************************************************************
 *            authwindow.h
 *
 *  Tue Mar 15 16:18:21 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _AUTHWINDOW_H
#define _AUTHWINDOW_H

#include "gettext.h"
#include "requestdialog.h"

/** The authorization window.
	This window allows the user to 
	- send an authorization
	- read an authorization request
	- refuse an authorization request
	
	It uses functions from RequestDialog
*/

class AuthorizeWindow: public RequestDialog
{
	public:
		/** The constructor
		@param _mode the event to install the window for. (UE_AUTHORIZATION, UE_AUTHORIZATIONREQUEST, UE_AUTHORIZATIONGRANT)
		*/
		AuthorizeWindow(UserEventType _mode);
	
		~AuthorizeWindow();
	
	
	private:
		UserEventType mode;
	
		/** Creates the window content. */
		GtkWidget* createWindowContent();
		/** Called after the window was focused. 
			Does nothing other than calling RequestDialog::focusWindow().*/
		void	   focusWindow();
		/** Destroys the window content. */
		void 	   destroyWindowContent();
	
		/** The event callback for the manager. */
		gboolean	eventCallback(gint command, gint lastResult, gpointer info);
	
		/** The notify callback for the request dialog. 
			Request dialogs use an own callback function to provide the result
			of the user action to the instance. 
			<i>FIXME: this is somehow loop like - don't use a callback but do it
			directly by overwriting the appropriate functions.</i>
		*/
		static void cb_notifyFunction(gint result, gpointer info, AuthorizeWindow *self);
};

#endif /* _AUTHWINDOW_H */
