/***************************************************************************
 *            groupswindow.h
 *
 *  Thu Jun 30 01:22:56 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _GROUPSWINDOW_H
#define _GROUPSWINDOW_H
#include "basicwindow.h"
#include "utilities.h"
#include "gettext.h"
#include "notebookbox.h"

typedef void (*GroupsWindowCallback)(gint command, gpointer data);

class GroupsWindow: public BasicWindow
{
	public:
		GroupsWindow(GroupsWindowCallback _cb, gpointer _cbdata);
		~GroupsWindow();
	
		
	protected:
		GroupsWindowCallback cb;
		gpointer	cbdata;	
	
		GtkListStore	*store;
		GtkWidget		*addButton,
						*removeButton,
						*upButton,
						*downButton,
						*editButton,
						*setDefaultButton,
						*setNewButton,
						*defaultGroupLabel,
						*newUsersGroupLabel,
						*closeButton,
						*saveButton,
						*tv;
		GtkCellRenderer *textRenderer;
	
		GtkTreeViewColumn	*textColumn;
	
		gushort			newUsersGroup,
						defaultGroup;
		guint			ownID;
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
	
		GtkWidget	*createGroupsList();
		GtkWidget	*createButtonbar();
	
		static void cb_groupListCursorChanged(GroupsWindow* self);
		static void cb_addButtonClicked(GroupsWindow* self);
		static void cb_removeButtonClicked(GroupsWindow* self);
		static void cb_upButtonClicked(GroupsWindow* self);
		static void cb_downButtonClicked(GroupsWindow* self);
		static void cb_editButtonClicked(GroupsWindow* self);
		static void cb_defaultGroupButtonClicked(GroupsWindow* self);
		static void cb_newGroupButtonClicked(GroupsWindow* self);
		static void cb_groupEntryEdited(GtkCellRendererText *cell, gchar *pathStr, gchar *newText, GroupsWindow* self);

		static void cb_saveButtonClicked(GroupsWindow* self);
		static void cb_closeButtonClicked(GroupsWindow* self);	
};


#endif /* _GROUPSWINDOW_H */
