/***************************************************************************
 *            imbuddy.h
 *
 *  Mon Jan 24 17:58:33 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef IMBUDDY_H
#define IMBUDDY_H

// we can do this later
#undef HAVE_LIBGPGME

#include <gtk/gtk.h>
#include "imuserdaemon.h"
#include "imownerdaemon.h"
#include "settings.h"

#include "mainwindow.h"
#include "convwindow.h"
#include "contactlist.h"
#include "ftwindow.h"
#include "chatwindow.h"
#include "infowindow.h"
#include "historywindow.h"
#include "authwindow.h"
#include "aresponsewindow.h"
#include "securitywindow.h"
#include "searchdialog.h"
#include "idactionwindow.h"
#include "groupswindow.h"
#include "messagewindow.h"
#include "modeswindow.h"
#include "newownerwindow.h"
#include "ownermanwindow.h"
#include "logwindow.h"
#include "optionswindow.h"
#include "contactswindow.h"
#include "icons.h"
#include "userutilities.h"
#include "randomchat.h"
#include "listswindow.h"
#include "statswindow.h"
#include "infooverviewwindow.h"
#include "passwordwindow.h"



// the real buddy: manages all windows that belong to a user
class IMBuddy
{
	public:	
		IMUserDaemon 	 *user;
		GList			 *cEntries;
		// contains all open events
		GList		 	*openEvents;
	
		IMBuddy(IMUserDaemon *_user);
		virtual ~IMBuddy();
	
		// opens an event making it readable (message window, file transfer...)
		BasicWindow* getOpenedEvent(UserEventType evType);
		virtual gboolean openEvent(UserEventType evType, gboolean isIncoming);
		virtual gboolean closeEvent(UserEventType evType);
	
		void closeAllEvents();
	
		// updates the status
		void updateIMContactListStatus(gboolean updateAlias);
		void updateIMContactListEvents(BasicEventInfo* ev, gboolean MoveToTop);
		void updateIMContactListStates();
	
		void putUserIntoGroups(IMContactListEntry* root, gboolean useRealName);
		
	protected:
		IMAutoResponseManager	*ARMan;	// for getting the auto response	
	
		GdkPixbuf* getEventSymbol(BasicEventInfo *info);
	
		// callbacks
		static gboolean cb_buddyCallback(UserEventType type, 
										 gint command, 
								  		 gint lastResult, gpointer info, 
								  		 IMBuddy* self);
		static void cb_SettingsChangedCallback(gchar* sname, GList *values, IMBuddy* self);
};





// the almighty icq owner
class IMOwner: public IMBuddy
{
	public:
		guchar errorCode;	

		MainWindow	*window;
		IMLogDaemon	*logDaemon;
	
		IMOwner();
		virtual ~IMOwner();
	
		// buddy functions
		IMBuddy	*getBuddy(gchar* licqID);
		UserEventType getWindowIDForEvent(gint eventType);
	
		// event functions
		gboolean openEvent(UserEventType evType, guint status);
		IMBuddy* getBuddyForLastGlobalEvent(gboolean favourSystemEvents, BasicEventInfo** info);
	
		// status functions
		void setStatus(guint status, gboolean promptAR = FALSE);

		gboolean autoConnect();
	
		// other functions
		void updateAllUsers();

		void rebuildIMContactList(gboolean dispatchEvents);

		// callbacks
		// general owner callback from IMOwnerDaemon
		static gboolean cb_ownerCallback(UserEventType type, 
										 gint command, 
								  		 gint lastResult, gpointer info, 
								  		 IMOwner* self);
		// global menu callback (is called every time a menu item has been selected
		static void		cb_menuCallback(gint menu, gint selection, gpointer itemData, IMOwner* self);
		// callback for dropping actions
		static void		cb_droppingCallback(IMContactListEntry *entry, guint type, GtkSelectionData *dragData, IMOwner* self);

		// callback for dialogs where a user must be selected (->IDActionWindow)
		static void		cb_idActionCallback(UserEventType type, gint command, gchar* id, guint pluginID, gchar* comment, gboolean toggled, IMOwner* self);
		// callback for the groups window
		static void		cb_groupWindowCallback(gint command, IMOwner* self);

		// callback for the general queue
		static gboolean cb_generalCallback(UserEventType type, gint command, gint lastResult, gpointer data, IMOwner* self);
		
		// callbacks for mass operations like "Update All Users"	
		static gboolean	cb_massEventCallback(UserEventType type, gint command, gint lastResult, gpointer info, IMOwner* self);

		// owner Settings callback
		static void cb_ownerSettingsChangedCallback(gchar* sname, GList *values, IMContactList* self);

		// callback when the window is closed
		static gboolean	cb_quitWindowCallback(IMOwner* self);
		
		// system idle check timeout
		static gboolean cb_checkIDLETimeout(IMOwner* self);

	
	protected:	
		time_t updateTime;
		gint eventCount,
			 ownerEventCount;	
	
		gboolean setupDefaultSettings();
		gboolean updateOneUser(IMContactListEntry* pos);
};



#endif
