/***************************************************************************
 *            logwindow.h
 *
 *  Fri Jul 22 01:11:22 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _LOGWINDOW_H
#define _LOGWINDOW_H

#include "basicwindow.h"
#include "imownerdaemon.h"
#include "settings.h"
#include "utilities.h"
#include "gettext.h"

class LogWindow: public BasicWindow
{
	public:
		LogWindow(IMLogDaemon* _logDaemon);
		~LogWindow();
		
	private:
		IMLogDaemon		*logDaemon;	
		GtkTextTagTable	*textTags;
		GtkWidget		*textView,
						*grepFilterEntry;
		guint			typeFilter;
		gchar			*grepFilter;
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
		GtkWidget	*createFilterbar();
		GtkWidget	*createButtonbar();
	
		void		displayMessages(GList* msg);
		void		clearMessageView();
	
		static gboolean	cb_loggingCallback(UserEventType type, gint command, gint lastResult, GList* log, LogWindow* self);
		static void		cb_clearButtonClicked(LogWindow* self);
		static void		cb_saveButtonClicked(LogWindow* self);
		static void		cb_closeButtonClicked(LogWindow* self);
	
		static void		cb_typeFilterChanged(GtkWidget* checkBox, LogWindow* self);
		static void		cb_grepFilterButtonClicked(LogWindow* self);
};

#endif /* _LOGWINDOW_H */
