/***************************************************************************
 *            newownerwindow.h
 *
 *  Fri Jul 15 02:14:47 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _NEWOWNERWINDOW_H
#define _NEWOWNERWINDOW_H

#include "icons.h"
#include "basicwindow.h"
#include "processingani.h"
#include "utilities.h"
#include "imownerdaemon.h"
#include "gettext.h"

enum NewOwnerActions
{
	NEWOWNER_ADD,
	NEWOWNER_CLOSE
};



class NewOwnerWindow: public BasicWindow
{
	public:
		NewOwnerWindow(gchar* _titleString);
		~NewOwnerWindow();
		
	private:
		GtkWidget	*notebook,
					*forwardButton,
					*backButton,
					*cancelButton,
					*registerUserButton,
					*useExistingUserButton,
					*protocolsList,
					*userIDEntry,
					*userPasswordEntry,
					*pwdConfirmEntry,
					*regHintLabel,
					*verifyImage,
					*verifyEntry,
					*pwdErrorEntry,
					*failedLabel,
					*newIDLabel,
					*oneAccountAlertLabel;
	
		gint		currentPage;
	
		gchar		*titleString;
		
		GString		*oneAlertMessage;
	
		ProcessingAni	*waitAni;
		IMOwnerDaemon	*newOwner;
		IMPluginDaemon	*lastDaemon;
	
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
	
		GtkWidget	*createTitlePage();
		GtkWidget	*createDataPage();
		GtkWidget	*createVerifyPage();
		GtkWidget	*createSuccessPage();
		GtkWidget	*createFailedPage();
		
		GtkWidget	*createButtonbar();
	
	
		void startProcessing();
		void stopProcessing();
	
		static gboolean cb_eventCallback(UserEventType type, gint command, gint lastResult, gpointer info, NewOwnerWindow* self);
	
		// callbacks
		static void cb_forwardButtonClicked(NewOwnerWindow* self);
		static void cb_backButtonClicked(NewOwnerWindow* self);
		static void cb_userActionButtonClicked(NewOwnerWindow* self);
		static void cb_closeButtonClicked(NewOwnerWindow* self);
		static void cb_editInfoButtonClicked(NewOwnerWindow* self);
		static void cb_editGroupsButtonClicked(NewOwnerWindow* self);
};


#endif /* _NEWOWNERWINDOW_H */
