/***************************************************************************
 *            ownermanwindow.h
 *
 *  Wed Jul 20 22:21:21 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _OWNERMANWINDOW_H
#define _OWNERMANWINDOW_H

#include "basicwindow.h"
#include "newownerwindow.h"
#include "imownerdaemon.h"
#include "utilities.h"
#include "gettext.h"


enum OwnerManagerActions
{
	OWNERMAN_ADD = 100,
	OWNERMAN_REMOVE,
	OWNERMAN_CLOSE,
	OWNERMAN_MODIFY
};


class OwnerManagerWindow: public BasicWindow
{
	public:
		OwnerManagerWindow();
		~OwnerManagerWindow();
	
	private:	
		GtkWidget	*addButton,
					*removeButton,
					*modifyButton,
					*protoView;
	
		GtkListStore	*protoStore;
	
		GtkWidget*	createWindowContent();
		GtkWidget*	createProtocolsList();
		void		destroyWindowContent();
	
		GtkWidget*	createButtonbar();
	
		gboolean	eventCallback(gint command, gint lastResult, gpointer info);
	
		static void cb_addButtonClicked(OwnerManagerWindow* self);
		static void cb_removeButtonClicked(OwnerManagerWindow* self);
		static void cb_closeButtonClicked(OwnerManagerWindow* self);
		static void cb_modifyButtonClicked(OwnerManagerWindow* self);
	
		static void cb_protocolsListCursorChanged(OwnerManagerWindow* self);	
};

#endif /* _OWNERMANWINDOW_H */
